Codeforces 295E Yaroslav and Points 线段树
明明区间合并一下就好的东西, 为什么我会写得这么麻烦的方法啊啊啊。
- #include<bits/stdc++.h>
- #define LL long long
- #define fi first
- #define se second
- #define mk make_pair
- #define PLL pair<LL, LL>
- #define PLI pair<LL, int>
- #define PII pair<int, int>
- #define SZ(x) ((int)x.size())
- #define ull unsigned long long
- using namespace std;
- const int N = 2e5 + ;
- const int inf = 0x3f3f3f3f;
- const LL INF = 0x3f3f3f3f3f3f3f3f;
- const int mod = 1e9 + ;
- const double eps = 1e-;
- const double PI = acos(-);
- vector<int> oo;
- int getPos(int x) {
- return lower_bound(oo.begin(), oo.end(), x) - oo.begin() + ;
- }
- int getPosL(int x) {
- return lower_bound(oo.begin(), oo.end(), x) - oo.begin() + ;
- }
- int getPosR(int x) {
- return upper_bound(oo.begin(), oo.end(), x) - oo.begin();
- }
- namespace SGT {
- #define lson l, mid, rt << 1
- #define rson mid + 1, r, rt << 1 | 1
- LL sum[N << ], cnt[N << ];
- LL lazya[N << ], lazyb[N << ], all[N << ];
- inline void push(int rt) {
- if(lazya[rt]) {
- lazya[rt << ] += lazya[rt];
- lazya[rt << | ] += lazya[rt];
- all[rt << ] += cnt[rt << ] * lazya[rt];
- all[rt << | ] += cnt[rt << | ] * lazya[rt];
- lazya[rt] = ;
- }
- if(lazyb[rt]) {
- lazyb[rt << ] += lazyb[rt];
- lazyb[rt << | ] += lazyb[rt];
- all[rt << ] += sum[rt << ] * lazyb[rt];
- all[rt << | ] += sum[rt << | ] * lazyb[rt];
- lazyb[rt] = ;
- }
- }
- inline void pull(int rt) {
- sum[rt] = sum[rt << ] + sum[rt << | ];
- cnt[rt] = cnt[rt << ] + cnt[rt << | ];
- all[rt] = all[rt << ] + all[rt << | ];
- }
- void modify1(int p, LL val, int l, int r, int rt) {
- if(l == r) {
- cnt[rt] += val;
- sum[rt] += oo[l - ] * val;
- if(!cnt[rt]) all[rt] = ;
- return;
- }
- push(rt);
- int mid = l + r >> ;
- if(p <= mid) modify1(p, val, lson);
- else modify1(p, val, rson);
- pull(rt);
- }
- void modify2(int L, int R, LL val, int l, int r, int rt) {
- if(L > R) return;
- if(l >= L && r <= R) {
- lazya[rt] += val;
- all[rt] += val * cnt[rt];
- return;
- }
- push(rt);
- int mid = l + r >> ;
- if(L <= mid) modify2(L, R, val, lson);
- if(R > mid) modify2(L, R, val, rson);
- pull(rt);
- }
- void modify3(int L, int R, LL val, int l, int r, int rt) {
- if(L > R) return;
- if(l >= L && r <= R) {
- lazyb[rt] += val;
- all[rt] += val * sum[rt];
- return;
- }
- push(rt);
- int mid = l + r >> ;
- if(L <= mid) modify3(L, R, val, lson);
- if(R > mid) modify3(L, R, val, rson);
- pull(rt);
- }
- PLL query1(int L, int R, int l, int r, int rt) {
- if(L > R) return mk(, );
- if(l >= L && r <= R) return mk(sum[rt], cnt[rt]);
- push(rt);
- int mid = l + r >> ;
- PLL ans = mk(, ), tmp = mk(, );
- if(L <= mid) {
- tmp = query1(L, R, lson);
- ans.fi += tmp.fi; ans.se += tmp.se;
- }
- if(R > mid) {
- tmp = query1(L, R, rson);
- ans.fi += tmp.fi; ans.se += tmp.se;
- }
- return ans;
- }
- LL query2(int L, int R, int l, int r, int rt) {
- if(L > R) return ;
- if(l >= L && r <= R) return all[rt];
- push(rt);
- int mid = l + r >> ;
- LL ans = ;
- if(L <= mid) ans += query2(L, R, lson);
- if(R > mid) ans += query2(L, R, rson);
- return ans;
- }
- }
- int n, m, x[N], c[N];
- pair<PII, int> qus[N];
- int main() {
- scanf("%d", &n);
- for(int i = ; i <= n; i++) {
- scanf("%d", &x[i]);
- c[i] = x[i];
- oo.push_back(x[i]);
- }
- scanf("%d", &m);
- for(int i = ; i <= m; i++) {
- scanf("%d%d%d", &qus[i].se, &qus[i].fi.fi, &qus[i].fi.se);
- if(qus[i].se == ) {
- c[qus[i].fi.fi] += qus[i].fi.se;
- oo.push_back(c[qus[i].fi.fi]);
- }
- }
- sort(oo.begin(), oo.end());
- oo.erase(unique(oo.begin(), oo.end()), oo.end());
- for(int i = ; i <= n; i++) SGT::modify1(getPos(x[i]), , , SZ(oo), );
- for(int i = ; i <= n; i++) {
- PLL add = SGT::query1(getPos(x[i]), SZ(oo), , SZ(oo), );
- SGT::modify2(getPos(x[i]), getPos(x[i]), add.fi, , SZ(oo), );
- SGT::modify3(getPos(x[i]), getPos(x[i]), -add.se, , SZ(oo), );
- }
- for(int i = ; i <= m; i++) {
- if(qus[i].se == ) {
- int p = qus[i].fi.fi, d = qus[i].fi.se;
- if(d > ) {
- SGT::modify1(getPos(x[p]), -, , SZ(oo), );
- SGT::modify2(, getPos(x[p]) - , d, , SZ(oo), );
- SGT::modify2(getPos(x[p]) + , getPos(x[p] + d) - , x[p] + d, , SZ(oo), );
- SGT::modify3(getPos(x[p]) + , getPos(x[p] + d) - , -, , SZ(oo), );
- x[p] += d;
- SGT::modify1(getPos(x[p]), , , SZ(oo), );
- PLL add = SGT::query1(getPos(x[p]), SZ(oo), , SZ(oo), );
- SGT::modify2(getPos(x[p]), getPos(x[p]), add.fi, , SZ(oo), );
- SGT::modify3(getPos(x[p]), getPos(x[p]), -add.se, , SZ(oo), );
- } else if(d < ) {
- d = -d;
- SGT::modify1(getPos(x[p]), -, , SZ(oo), );
- SGT::modify2(, getPos(x[p] - d) - , -d, , SZ(oo), );
- SGT::modify2(getPos(x[p] - d) + , getPos(x[p]) - , -x[p], , SZ(oo), );
- SGT::modify3(getPos(x[p] - d) + , getPos(x[p]) - , , , SZ(oo), );
- x[p] -= d;
- SGT::modify1(getPos(x[p]), , , SZ(oo), );
- PLL add = SGT::query1(getPos(x[p]), SZ(oo), , SZ(oo), );
- SGT::modify2(getPos(x[p]), getPos(x[p]), add.fi, , SZ(oo), );
- SGT::modify3(getPos(x[p]), getPos(x[p]), -add.se, , SZ(oo), );
- }
- } else {
- int L = qus[i].fi.fi, R = qus[i].fi.se;
- L = getPosL(L); R = getPosR(R);
- LL ans = SGT::query2(L, R, , SZ(oo), );
- PLL tmpL = SGT::query1(L, R, , SZ(oo), );
- PLL tmpR = SGT::query1(R + , SZ(oo), , SZ(oo), );
- ans -= tmpL.se * tmpR.fi;
- ans += tmpL.fi * tmpR.se;
- printf("%lld\n", ans);
- }
- }
- return ;
- }
- /*
- */
Codeforces 295E Yaroslav and Points 线段树的更多相关文章
- Codeforces Beta Round #19D(Points)线段树
D. Points time limit per test 2 seconds memory limit per test 256 megabytes input standard input out ...
- codeforces 295E Yaroslav and Points (离线操作+离散化+区间合并)
参考链接:http://blog.csdn.net/dyx404514/article/details/8817717 写的很详细,这里就不再赘述,附上我的代码. #include <iostr ...
- codeforces Good bye 2016 E 线段树维护dp区间合并
codeforces Good bye 2016 E 线段树维护dp区间合并 题目大意:给你一个字符串,范围为‘0’~'9',定义一个ugly的串,即串中的子串不能有2016,但是一定要有2017,问 ...
- Codeforces 1140F Extending Set of Points 线段树 + 按秩合并并查集 (看题解)
Extending Set of Points 我们能发现, 如果把x轴y轴看成点, 那么答案就是在各个连通块里面的x轴的个数乘以y轴的个数之和. 然后就变成了一个并查集的问题, 但是这个题目里面有撤 ...
- CodeForces 19D Points (线段树+set)
D. Points time limit per test 2 seconds memory limit per test 256 megabytes input standard input out ...
- Codeforces 1140F Extending Set of Points (线段树分治+并查集)
这题有以下几个步骤 1.离线处理出每个点的作用范围 2.根据线段树得出作用范围 3.根据分治把每个范围内的点记录和处理 #include<bits/stdc++.h> using name ...
- codeforces 22E XOR on Segment 线段树
题目链接: http://codeforces.com/problemset/problem/242/E E. XOR on Segment time limit per test 4 seconds ...
- Codeforces 588E. A Simple Task (线段树+计数排序思想)
题目链接:http://codeforces.com/contest/558/problem/E 题意:有一串字符串,有两个操作:1操作是将l到r的字符串升序排序,0操作是降序排序. 题解:建立26棵 ...
- Codeforces Gym 100803G Flipping Parentheses 线段树+二分
Flipping Parentheses 题目连接: http://codeforces.com/gym/100803/attachments Description A string consist ...
随机推荐
- (并发编程)RLock(与死锁现象),Semaphore,Even事件,线程Queue
一.死锁现象与递归锁所谓死锁: 是指两个或两个以上的进程或线程在执行过程中,因争夺资源而造成的一种互相等待的现象,若无外力作用,它们都将无法推进下去.此时称系统处于死锁状态或系统产生了死锁,这些永远在 ...
- ssdb主从及双主模型配置和简单管理
ssdb主从及双主模型配置和简单管理 levelDB是一个key->value 的数据存储库,其只能在本地保存数据,支持持久化,并且支持保存非常大的数据,单机redis在保存较大数据的时候数十G ...
- 查看和解除Linux系统对用户使用资源的限制
查看当前系统资源限制 ulimit -a 设置用户的最大进程数(重启后失效) ulimit -u 1024 设置用户可以打开的最大文件句柄数(重启后失效) ulimit -n 65530 ...
- [转]MingGW64 多个版本区别(silj, seh)
1 引言 在https://sourceforge.net/projects/mingw-w64上会看到MinGW有各种版本如下,但区别在于哪儿呢 MinGW-W64 GCC-8.1.0 x86_64 ...
- vue v-time指令封装(接口返回时间戳 在到日期转换)
// 全局时间戳转换指令注册Vue.directive('time',{ bind: function (el,binding) { let getTime = new Date(binding.va ...
- Codeforces 1039D You Are Given a Tree [根号分治,整体二分,贪心]
洛谷 Codeforces 根号分治真是妙啊. 思路 考虑对于单独的一个\(k\)如何计算答案. 与"赛道修建"非常相似,但那题要求边,这题要求点,所以更加简单. 在每一个点贪心地 ...
- ECS分区挂载数据盘
地址:https://help.aliyun.com/document_detail/25426.html?spm=5176.11065259.1996646101.searchclickresult ...
- Confluence 6 访问日志脚本
日志访问脚本在连接:https://confluence.atlassian.com/download/attachments/133267635/Atlassian-accessLogScripts ...
- Confluence 6 数据库表-展现(Appearance)
这部分存储了有关你 Confluence 的外观和布局使用的信息. decorator 使用自定义 Velocity 布局显示的自定义模板. https://www.cwiki.us/display/ ...
- Confluence 6 自定义站点和空间布局
你可以通过编辑布局文件来修改 Confluence 的外观和感觉(也可以被称为装饰).编辑这些文件将会允许你对整个 Confluence 站点的外观和感觉进行修改或者仅仅是一个独立的空间. 当你对一个 ...